#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define yyparse rcsparse
#define yylex rcslex
#define yyerror rcserror
#define yychar rcschar
#define yyval rcsval
#define yylval rcslval
#define yydebug rcsdebug
#define yynerrs rcsnerrs
#define yyerrflag rcserrflag
#define yyss rcsss
#define yyssp rcsssp
#define yyvs rcsvs
#define yyvsp rcsvsp
#define yylhs rcslhs
#define yylen rcslen
#define yydefred rcsdefred
#define yydgoto rcsdgoto
#define yysindex rcssindex
#define yyrindex rcsrindex
#define yygindex rcsgindex
#define yytable rcstable
#define yycheck rcscheck
#define yyname rcsname
#define yyrule rcsrule
#define yysslim rcssslim
#define yystacksize rcsstacksize
#define YYPREFIX "rcs"
#line 23 "rcsy.y"
#define YYERROR_VERBOSE	1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <gd.h>		/* For gdFontPtr in cvsgraph.h */
#include "cvsgraph.h"
#include "utils.h"
#include "rcs.h"

rcsfile_t *rcsfile;

static tag_t *new_tag(char *s, char *r);
static tags_t *new_tags(tag_t *s);
static tags_t *add_tags(tags_t *s, tag_t *t);
static idrev_t *new_idrev(char *s, char *r);
static idrevs_t *new_idrevs(idrev_t *s);
static idrevs_t *add_idrevs(idrevs_t *s, idrev_t *t);
static ids_t *new_ids(char *s);
static ids_t *add_ids(ids_t *s, char *t);
static revs_t *new_revs(char *s);
static revs_t *add_revs(revs_t *s, char *t);
static dtext_t *new_dtext(char *n, char *l, char *t);
static dtexts_t *add_dtexts(dtexts_t *s, dtext_t *t);
static phrase_t *new_phrase(phrase_type_e pt, char *t);
static phrases_t *add_phrases(phrases_t *s, phrase_t *t);
static delta_t *new_delta(char *rev, char *date, char *author, char *state, revs_t *branches, char *next, phrases_t *phrases);
static deltas_t *add_deltas(deltas_t *s, delta_t *t);
static rcsfile_t *new_rcsfile(char *head, char *branch, ids_t *access, tags_t *tags,
				idrevs_t *locks, int strict, char *comment, char *expand);

#line 58 "rcsy.y"
typedef union{
	int		i;
	char		*str;
	tag_t		*tag;
	tags_t		*tags;
	idrev_t		*idrev;
	idrevs_t	*idrevs;
	ids_t		*ids;
	revs_t		*revs;
	dtext_t		*dtext;
	dtexts_t	*dtexts;
	delta_t		*delta;
	deltas_t	*deltas;
	rcsfile_t	*rcsfile;
	phrases_t	*phrases;
	phrase_t	*phrase;
} YYSTYPE;
#line 95 "rcs.tab.c"
#define YYERRCODE 256
#define tHEAD 257
#define tBRANCH 258
#define tACCESS 259
#define tSYMBOLS 260
#define tLOCKS 261
#define tSTRICT 262
#define tCOMMENT 263
#define tEXPAND 264
#define tDATE 265
#define tAUTHOR 266
#define tSTATE 267
#define tBRANCHES 268
#define tNEXT 269
#define tDESC 270
#define tLOG 271
#define tTEXT 272
#define tOWNER 273
#define tGROUP 274
#define tPERMISSIONS 275
#define tSPECIAL 276
#define tSYMLINK 277
#define tHARDLINKS 278
#define tNAMESPACE 279
#define tDEAD 280
#define tMERGEPOINT 281
#define tDELTATYPE 282
#define tCOMMITID 283
#define tKOPT 284
#define tFILENAME 285
#define tNEWPHRASE 286
#define tSTRING 287
#define tREV 288
#define tID 289
#define tSYM 290
const short rcslhs[] = {                                        -1,
   27,    0,   28,   29,   30,   24,   19,   19,    4,    4,
    5,    5,    6,    6,   23,   23,   31,   32,   22,    8,
    8,    7,   21,   21,   33,   20,   25,   25,   34,   26,
   36,   26,   38,   26,   26,   35,   35,   35,   35,   35,
   35,   37,   37,   37,   37,   37,   37,    1,    1,    2,
    2,   18,   18,   17,   17,    3,    3,   16,   16,   15,
   15,   14,   14,   13,   13,   12,   11,   11,   10,   10,
    9,    9,
};
const short rcslen[] = {                                         2,
    0,    5,    0,    0,    0,   20,    0,    2,    0,    3,
    0,    3,    0,    3,    0,    2,    0,    0,   19,    1,
    1,    2,    0,    2,    0,    7,    0,    2,    0,    3,
    0,    3,    0,    3,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    0,    1,    0,
    1,    0,    1,    1,    2,    0,    1,    0,    1,    1,
    2,    0,    1,    1,    2,    3,    0,    1,    1,    2,
    3,    4,
};
const short rcsdefred[] = {                                      0,
    0,    0,   15,   51,    0,    0,    0,    0,    0,    1,
   16,    0,    0,   22,    0,   23,    0,    3,    0,    0,
   10,    0,    0,    0,   24,   60,    0,    0,   17,    0,
   61,    0,    0,   27,    4,   21,   20,    0,    0,    0,
    0,   25,   36,   37,   38,   39,   40,   41,   42,   43,
    0,   44,   45,   46,   47,   29,   28,   31,   33,    0,
    0,   69,    0,    0,   18,    0,    0,    0,    0,    0,
    0,    0,   70,    0,    0,   26,   35,   30,   32,   34,
   71,    0,    5,   57,    0,   72,    0,    0,    0,   64,
    0,    0,    0,    0,   65,    0,   54,    0,    0,   66,
    0,    0,   55,    0,    8,    0,    0,    0,   49,    0,
    0,   27,    0,   12,    0,    0,   27,   14,    0,
};
const short rcsdgoto[] = {                                       2,
  110,    5,   85,   13,  107,  112,   10,   38,   62,   63,
   64,   90,   91,   92,   27,   28,   98,   99,  102,   25,
   20,   11,    6,    3,   39,   57,   16,   22,   40,   87,
   33,   75,   66,   68,   58,   69,   59,   70,
};
const short rcssindex[] = {                                   -252,
 -281,    0,    0,    0,  -51, -260, -228, -256, -231,    0,
    0, -281, -193,    0, -189,    0,   41,    0,   42, -186,
    0, -185, -161, -165,    0,    0, -182,   49,    0, -178,
    0, -150, -283,    0,    0,    0,    0,   52, -204,  -58,
 -155,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -174,    0,    0,    0,    0,    0,    0,    0,    0,   56,
 -173,    0,  -58,   57,    0, -170,   59,   60,   61,   62,
 -166,   65,    0, -137, -164,    0,    0,    0,    0,    0,
    0, -160,    0,    0,   67,    0, -159, -140,   71,    0,
 -159,   72, -156, -154,    0, -129,    0, -153,   77,    0,
   78, -125,    0, -130,    0, -147, -123, -281,    0,   83,
 -147,    0,   84,    0,   85, -190,    0,    0, -190,
};
const short rcsrindex[] = {                                      0,
   86,    0,    0,    0,    0,    0, -113,    0,    0,    0,
    0,   86,    0,    0,    0,    0,    0,    0,    0,  147,
    0,   89,    0,    0,    0,    0,   90,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   91,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   92,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   93,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   94,    0,    0,    0,
   95,    0,   96,    0,    0, -261,    0,   97,    0,    0,
    0, -238,    0,    0,    0,   98, -221,   86,    0,    0,
   98,    0,    0,    0,    0, -259,    0,    0, -237,
};
const short rcsgindex[] = {                                      0,
   47,  -11,    0,    0,    0,    0,    0,    0,   99,    0,
    0,   68,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -14,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 232
const short rcstable[] = {                                      61,
   17,    7,    7,   36,    1,   37,    4,    7,    7,    8,
    6,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,   11,    7,    9,    6,   12,
   14,   11,   19,   15,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   13,   11,
   19,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   18,   13,   42,   43,   44,
   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
   55,   56,   43,   44,   45,   46,   47,   48,   49,   50,
   51,   52,   53,   54,   55,   56,  113,  116,   19,   21,
   23,   24,  119,   26,   29,   30,   31,   32,   34,   35,
   41,   65,   67,   71,   72,   74,   76,   77,   78,   79,
   80,   81,   82,   83,   84,   88,   86,   93,   94,   89,
   96,   97,  101,  100,  103,  104,  105,  106,  108,  109,
  111,  114,  117,  118,   50,    9,    2,   58,   59,   67,
   68,   56,   62,   63,   52,   53,   48,  115,   95,    0,
    0,   73,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   60,
};
const short rcscheck[] = {                                      58,
   12,  263,  264,  287,  257,  289,  288,   59,  270,  270,
  270,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  264,  288,  288,  288,  258,
  287,  270,  270,  265,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  270,  288,
  288,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  259,  288,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  108,  112,  288,   59,
   59,  288,  117,  289,  266,  271,  289,   59,  287,  260,
   59,  267,  287,   58,  288,   59,  287,   59,   59,   59,
   59,  288,   58,  261,  289,   59,  287,  268,   58,  289,
   59,  288,  262,  288,  288,   59,   59,  263,  269,  287,
  264,   59,   59,   59,   59,  259,    0,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,  111,   91,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  290,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#define YYMAXTOKEN 290
#if YYDEBUG
const char * const rcsname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"':'","';'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"tHEAD","tBRANCH",
"tACCESS","tSYMBOLS","tLOCKS","tSTRICT","tCOMMENT","tEXPAND","tDATE","tAUTHOR",
"tSTATE","tBRANCHES","tNEXT","tDESC","tLOG","tTEXT","tOWNER","tGROUP",
"tPERMISSIONS","tSPECIAL","tSYMLINK","tHARDLINKS","tNAMESPACE","tDEAD",
"tMERGEPOINT","tDELTATYPE","tCOMMITID","tKOPT","tFILENAME","tNEWPHRASE",
"tSTRING","tREV","tID","tSYM",
};
const char * const rcsrule[] = {
"$accept : rcsfile",
"$$1 :",
"rcsfile : admin deltas desc $$1 dtexts",
"$$2 :",
"$$3 :",
"$$4 :",
"admin : tHEAD orev ';' obranch tACCESS $$2 oids ';' tSYMBOLS $$3 otags ';' tLOCKS $$4 oidrevs ';' ostrict ocomment oexpand ophrases",
"ostrict :",
"ostrict : tSTRICT ';'",
"obranch :",
"obranch : tBRANCH orev ';'",
"ocomment :",
"ocomment : tCOMMENT ostr ';'",
"oexpand :",
"oexpand : tEXPAND ostr ';'",
"deltas :",
"deltas : deltas delta",
"$$5 :",
"$$6 :",
"delta : tREV tDATE tREV ';' tAUTHOR $$5 idorstr ';' tSTATE $$6 oid ';' tBRANCHES orevs ';' tNEXT orev ';' ophrases",
"idorstr : tID",
"idorstr : tSTRING",
"desc : tDESC tSTRING",
"dtexts :",
"dtexts : dtexts dtext",
"$$7 :",
"dtext : tREV tLOG tSTRING ophrases tTEXT $$7 tSTRING",
"ophrases :",
"ophrases : ophrases phrase",
"$$8 :",
"phrase : tNEWPHRASE $$8 ';'",
"$$9 :",
"phrase : cvskw $$9 ';'",
"$$10 :",
"phrase : otherkw $$10 ';'",
"phrase : tMERGEPOINT tSTRING ';'",
"cvskw : tOWNER",
"cvskw : tGROUP",
"cvskw : tPERMISSIONS",
"cvskw : tSPECIAL",
"cvskw : tSYMLINK",
"cvskw : tHARDLINKS",
"otherkw : tNAMESPACE",
"otherkw : tDEAD",
"otherkw : tDELTATYPE",
"otherkw : tCOMMITID",
"otherkw : tKOPT",
"otherkw : tFILENAME",
"ostr :",
"ostr : tSTRING",
"orev :",
"orev : tREV",
"orevs :",
"orevs : revs",
"revs : tREV",
"revs : revs tREV",
"oid :",
"oid : tID",
"oids :",
"oids : ids",
"ids : tID",
"ids : ids tID",
"oidrevs :",
"oidrevs : idrevs",
"idrevs : idrev",
"idrevs : idrevs idrev",
"idrev : tID ':' tREV",
"otags :",
"otags : tags",
"tags : tag",
"tags : tags tag",
"tag : tSYM ':' tREV",
"tag : ':' tREV ':' tSTRING",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 285 "rcsy.y"
static rev_t *make_rev(char *s, int isrev)
{
	char *cptr;
	int dots = 0;
	rev_t *r;

	if(!s)
		return NULL;

	r = xmalloc(sizeof(*r));

	for(cptr = s; *cptr; cptr++)
	{
		if(*cptr == '.')
			dots++;
	}
	if(!dots)
	{
		r->rev = xstrdup("");
		r->branch = xstrdup(s);
		r->isbranch = 1;
	}
	else if(!*s)
	{
		r->rev = xstrdup("?.?");
		r->branch = xstrdup("?");
	}
	else if(dots & 1)
	{
		char *t;
		r->rev = s;
		r->branch = xstrdup(s);
		cptr = strrchr(r->branch, '.');
		assert(cptr != NULL);
		*cptr = '\0';
		t = strrchr(r->branch, '.');
		if(!isrev && ((t && !strcmp(t+1, "0")) || (!t && !strcmp(r->branch, "0"))))
		{
			/* Magic branch numbers "x.x.0.x" */
			r->isbranch = 1;
			if(t)
				strcpy(t+1, cptr+1);
			else
				strcpy(r->branch, cptr+1);
		}
	}
	else
	{
		r->isbranch = 1;
		r->branch = s;
		r->rev = xmalloc(strlen(s) + 3);
		strcpy(r->rev, s);
		strcat(r->rev, ".?");
	}
	return r;
}


static tag_t *new_tag(char *s, char *r)
{
	tag_t *t = xmalloc(sizeof(*t));
	t->tag = s;
	t->rev = make_rev(r, 0);
	return t;
}

static tags_t *new_tags(tag_t *s)
{
	tags_t *t = xmalloc(sizeof(*t));
	t->ntags = 1;
	t->tags = xmalloc(sizeof(t->tags[0]));
	t->tags[0] = s;
	return t;
}

static tags_t *add_tags(tags_t *s, tag_t *t)
{
	if(!s)
		return new_tags(t);
	s->tags = xrealloc(s->tags, (s->ntags+1) * sizeof(s->tags[0]));
	s->tags[s->ntags] = t;
	s->ntags++;
	return s;
}

static idrev_t *new_idrev(char *s, char *r)
{
	idrev_t *t = xmalloc(sizeof(*t));
	t->id = s;
	t->rev = make_rev(r, 1);
	return t;
}

static idrevs_t *new_idrevs(idrev_t *s)
{
	idrevs_t *t = xmalloc(sizeof(*t));
	t->nidrevs = 1;
	t->idrevs = xmalloc(sizeof(t->idrevs[0]));
	t->idrevs[0] = s;
	return t;
}

static idrevs_t *add_idrevs(idrevs_t *s, idrev_t *t)
{
	if(!s)
		return new_idrevs(t);
	s->idrevs = xrealloc(s->idrevs, (s->nidrevs+1) * sizeof(s->idrevs[0]));
	s->idrevs[s->nidrevs] = t;
	s->nidrevs++;
	return s;
}

static ids_t *new_ids(char *s)
{
	ids_t *t = xmalloc(sizeof(*t));
	t->nids = 1;
	t->ids = xmalloc(sizeof(t->ids[0]));
	t->ids[0] = s;
	return t;
}

static ids_t *add_ids(ids_t *s, char *t)
{
	s->ids = xrealloc(s->ids, (s->nids+1) * sizeof(s->ids[0]));
	s->ids[s->nids] = t;
	s->nids++;
	return s;
}

static revs_t *new_revs(char *s)
{
	revs_t *t = xmalloc(sizeof(*t));
	t->nrevs = 1;
	t->revs = xmalloc(sizeof(t->revs[0]));
	t->revs[0] = make_rev(s, 1);
	return t;
}

static revs_t *add_revs(revs_t *s, char *t)
{
	s->revs = xrealloc(s->revs, (s->nrevs+1) * sizeof(s->revs[0]));
	s->revs[s->nrevs] = make_rev(t, 1);
	s->nrevs++;
	return s;
}

static dtext_t *new_dtext(char *n, char *l, char *t)
{
	dtext_t *d = xmalloc(sizeof(*d));
	d->rev = make_rev(n, 1);
	d->log = l;
	d->text = t;
	return d;
}

static dtexts_t *add_dtexts(dtexts_t *s, dtext_t *t)
{
	if(!s)
		s = xmalloc(sizeof(*s));
	s->dtexts = xrealloc(s->dtexts, (s->ndtexts+1) * sizeof(s->dtexts[0]));
	s->dtexts[s->ndtexts] = t;
	s->ndtexts++;
	return s;
}

static phrase_t *new_phrase(phrase_type_e pt, char *t)
{
	phrase_t *d = xmalloc(sizeof(*d));
	d->type = pt;
	d->rev = make_rev(t, 1);
	return d;
}
	
static phrases_t *add_phrases(phrases_t *s, phrase_t *t)
{
	if(!t)
		return s;
	if(!s)
		s = xmalloc(sizeof(*s));
	if(t)
	{
		s->phrases = xrealloc(s->phrases, (s->nphrases + 1) * sizeof(s->phrases[0]));
		s->phrases[s->nphrases] = t;
		s->nphrases++;
	}
	return s;
}

static phrase_t *find_mergepoint(phrases_t *p)
{
	int i;

	if(!p)
		return NULL;

	for(i = 0; i < p->nphrases; i++)
	{
		if(p->phrases[i]->type == PT_MERGEPOINT)
			return p->phrases[i];
	}
	return NULL;
}

static delta_t *new_delta(char *rev, char *date, char *author, char *state, revs_t *branches, char *next, phrases_t *phrases)
{
	delta_t *d = xmalloc(sizeof(*d));
	d->rev = make_rev(rev, 1);
	d->date = date;
	d->author = author;
	d->state = state;
	d->branches = branches;
	d->next = make_rev(next, 1);
	d->phrases = phrases;
	d->mergepoint = find_mergepoint(phrases);
	return d;
}

static deltas_t *add_deltas(deltas_t *s, delta_t *t)
{
	if(!s)
		s = xmalloc(sizeof(*s));
	s->deltas = xrealloc(s->deltas, (s->ndeltas+1) * sizeof(s->deltas[0]));
	s->deltas[s->ndeltas] = t;
	s->ndeltas++;
	return s;
}

static rcsfile_t *new_rcsfile(char *head, char *branch, ids_t *access, tags_t *tags,
				idrevs_t *locks, int strict, char *comment, char *expand)
{
	rcsfile_t *r = xmalloc(sizeof(*r));
	r->head = make_rev(head, 1);
	r->branch = make_rev(branch, 0);
	r->access = access;
	r->tags = tags;
	r->locks = locks;
	r->strict = strict;
	r->comment = comment;
	r->expand = expand;
	return r;
}

#line 624 "rcs.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 103 "rcsy.y"
{
		rcsfile = yyvsp[-2].rcsfile;
		rcsfile->deltas = yyvsp[-1].deltas;
		rcsfile->desc = yyvsp[0].str;
		rcsfile->dtexts = NULL;
		if(rcsfile->head)
		{
			char *h = xstrdup("HEAD");
			char *r = xstrdup(rcsfile->head->rev);
			tag_t *t = new_tag(h, r);
			t->ignore = -1;	/* Make sure it doesn't get zapped */
			rcsfile->tags = add_tags(rcsfile->tags, t);
		}
		if(rcsfile->branch)
		{
			char *h = xstrdup("MAIN");
			char *r = xstrdup(rcsfile->branch->rev);
			tag_t *t = new_tag(h, r);
			t->rev->isbranch = 1;
			rcsfile->tags = add_tags(rcsfile->tags, t);
		}
		/* Else we need to add the main tag later because the
		 * trunk is reversed in order and the primary revision
		 * numbers can vary.
		 */
		if(!conf.parse_logs)
		{
			/* Return from the yyparse() call early to avoid parsing
			 * of the possibly extremely large deltatext. This speeds
			 * up parsing of binary files by a very large factor.
			 */
			return 0;
		}
		}
break;
case 2:
#line 139 "rcsy.y"
{ rcsfile->dtexts = yyvsp[0].dtexts; }
break;
case 3:
#line 144 "rcsy.y"
{ set_id(); }
break;
case 4:
#line 145 "rcsy.y"
{ set_sym(); }
break;
case 5:
#line 146 "rcsy.y"
{ set_id(); }
break;
case 6:
#line 149 "rcsy.y"
{ yyval.rcsfile = new_rcsfile(yyvsp[-18].str, yyvsp[-16].str, yyvsp[-13].ids, yyvsp[-9].tags, yyvsp[-5].idrevs, yyvsp[-3].i, yyvsp[-2].str, yyvsp[-1].str); }
break;
case 7:
#line 152 "rcsy.y"
{ yyval.i = 0; }
break;
case 8:
#line 153 "rcsy.y"
{ yyval.i = 1; }
break;
case 9:
#line 156 "rcsy.y"
{ yyval.str = NULL; }
break;
case 10:
#line 157 "rcsy.y"
{ yyval.str = yyvsp[-1].str; }
break;
case 11:
#line 160 "rcsy.y"
{ yyval.str = NULL; }
break;
case 12:
#line 161 "rcsy.y"
{ yyval.str = yyvsp[-1].str; }
break;
case 13:
#line 164 "rcsy.y"
{ yyval.str = NULL; }
break;
case 14:
#line 165 "rcsy.y"
{ yyval.str = yyvsp[-1].str; }
break;
case 15:
#line 168 "rcsy.y"
{ yyval.deltas = NULL; }
break;
case 16:
#line 169 "rcsy.y"
{ yyval.deltas = add_deltas(yyvsp[-1].deltas, yyvsp[0].delta); }
break;
case 17:
#line 174 "rcsy.y"
{ set_author(); }
break;
case 18:
#line 175 "rcsy.y"
{ set_id(); }
break;
case 19:
#line 178 "rcsy.y"
{ yyval.delta = new_delta(yyvsp[-18].str, yyvsp[-16].str, yyvsp[-12].str, yyvsp[-8].str, yyvsp[-5].revs, yyvsp[-2].str, yyvsp[0].phrases); }
break;
case 20:
#line 181 "rcsy.y"
{ yyval.str = yyvsp[0].str; }
break;
case 21:
#line 182 "rcsy.y"
{ yyval.str = yyvsp[0].str; }
break;
case 22:
#line 185 "rcsy.y"
{ yyval.str = yyvsp[0].str; }
break;
case 23:
#line 188 "rcsy.y"
{ yyval.dtexts = NULL; }
break;
case 24:
#line 189 "rcsy.y"
{ yyval.dtexts = add_dtexts(yyvsp[-1].dtexts, yyvsp[0].dtext); }
break;
case 25:
#line 195 "rcsy.y"
{ set_skipstr(); }
break;
case 26:
#line 195 "rcsy.y"
{ yyval.dtext = new_dtext(yyvsp[-6].str, yyvsp[-4].str, yyvsp[0].str); }
break;
case 27:
#line 198 "rcsy.y"
{ yyval.phrases = NULL; }
break;
case 28:
#line 199 "rcsy.y"
{ yyval.phrases = add_phrases(yyvsp[-1].phrases, yyvsp[0].phrase); }
break;
case 29:
#line 202 "rcsy.y"
{ set_skip(); }
break;
case 30:
#line 202 "rcsy.y"
{
		yywarning("Unrecognised `newphrase keyword '%s' skipped", yyvsp[-2].str);
		xfree(yyvsp[-2].str);
		yyval.phrase = NULL;
		}
break;
case 31:
#line 207 "rcsy.y"
{ set_skip(); }
break;
case 32:
#line 207 "rcsy.y"
{ yyval.phrase = NULL; /* yywarning("CVS extended keyword skipped"); */ }
break;
case 33:
#line 208 "rcsy.y"
{ set_skip(); }
break;
case 34:
#line 208 "rcsy.y"
{ yyval.phrase = NULL; /* yywarning("Other extended keyword"); */ }
break;
case 35:
#line 209 "rcsy.y"
{ yyval.phrase = new_phrase(PT_MERGEPOINT, yyvsp[-1].str); }
break;
case 48:
#line 228 "rcsy.y"
{ yyval.str = NULL; }
break;
case 49:
#line 229 "rcsy.y"
{ yyval.str = yyvsp[0].str; }
break;
case 50:
#line 232 "rcsy.y"
{ yyval.str = NULL; }
break;
case 51:
#line 233 "rcsy.y"
{ yyval.str = yyvsp[0].str; }
break;
case 52:
#line 236 "rcsy.y"
{ yyval.revs = NULL; }
break;
case 53:
#line 237 "rcsy.y"
{ yyval.revs = yyvsp[0].revs; }
break;
case 54:
#line 240 "rcsy.y"
{ yyval.revs = new_revs(yyvsp[0].str); }
break;
case 55:
#line 241 "rcsy.y"
{ yyval.revs = add_revs(yyvsp[-1].revs, yyvsp[0].str); }
break;
case 56:
#line 244 "rcsy.y"
{ yyval.str = NULL; }
break;
case 57:
#line 245 "rcsy.y"
{ yyval.str = yyvsp[0].str; }
break;
case 58:
#line 248 "rcsy.y"
{ yyval.ids = NULL; }
break;
case 59:
#line 249 "rcsy.y"
{ yyval.ids = yyvsp[0].ids; }
break;
case 60:
#line 252 "rcsy.y"
{ yyval.ids = new_ids(yyvsp[0].str); }
break;
case 61:
#line 253 "rcsy.y"
{ set_id(); yyval.ids = add_ids(yyvsp[-1].ids, yyvsp[0].str); }
break;
case 62:
#line 256 "rcsy.y"
{ yyval.idrevs = NULL; }
break;
case 63:
#line 257 "rcsy.y"
{ yyval.idrevs = yyvsp[0].idrevs; }
break;
case 64:
#line 260 "rcsy.y"
{ yyval.idrevs = new_idrevs(yyvsp[0].idrev); }
break;
case 65:
#line 261 "rcsy.y"
{ yyval.idrevs = add_idrevs(yyvsp[-1].idrevs, yyvsp[0].idrev); }
break;
case 66:
#line 264 "rcsy.y"
{ set_id(); yyval.idrev = new_idrev(yyvsp[-2].str, yyvsp[0].str); }
break;
case 67:
#line 267 "rcsy.y"
{ yyval.tags = NULL; }
break;
case 68:
#line 268 "rcsy.y"
{ yyval.tags = yyvsp[0].tags; }
break;
case 69:
#line 271 "rcsy.y"
{ if(yyvsp[0].tag) yyval.tags = new_tags(yyvsp[0].tag); else yyval.tags = NULL; }
break;
case 70:
#line 272 "rcsy.y"
{ if(yyvsp[-1].tags && yyvsp[0].tag) yyval.tags = add_tags(yyvsp[-1].tags, yyvsp[0].tag); else if(yyvsp[0].tag) yyval.tags = new_tags(yyvsp[0].tag); else yyval.tags = yyvsp[-1].tags; }
break;
case 71:
#line 275 "rcsy.y"
{ set_sym(); yyval.tag = new_tag(yyvsp[-2].str, yyvsp[0].str); }
break;
case 72:
#line 281 "rcsy.y"
{ set_sym(); yyval.tag = NULL; }
break;
#line 1096 "rcs.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
